dofile( "data/scripts/lib/utilities.lua" )


local player = GetUpdatedEntityID()

local x, y = EntityGetTransform(player)

local nearby_entities = EntityGetInRadius( x, y, 300 )

for k, entity in ipairs(nearby_entities) do
	if(EntityHasTag(entity, "is_mimic") == false)then
		local physics_body_component = EntityGetFirstComponent(entity, "PhysicsBodyComponent")
		local physics_body2_component = EntityGetFirstComponent(entity, "PhysicsBody2Component")
		if(physics_body2_component ~= nil) or (physics_body_component ~= nil)then
			local physics_ai_component = EntityGetFirstComponent(entity, "PhysicsAIComponent")
			if(physics_ai_component == nil)then
				EntityAddComponent( entity, "PhysicsAIComponent", { 
					target_vec_max_len="20.0",
					force_coeff="40.0",
					force_balancing_coeff="1.8",
					force_max="120",
					torque_coeff="50",
					torque_balancing_coeff="0.9",
					torque_max="1.0",
					rotation_speed="1",
					damage_deactivation_probability="20",
					damage_deactivation_time_min="20",
					damage_deactivation_time_max="40",
				})
				EntityAddComponent( entity, "AnimalAIComponent", {
					preferred_job="JobDefault",
					attack_ranged_min_distance="0",
					attack_ranged_max_distance="50",
					creature_detection_range_x="300",
					creature_detection_range_y="300",
					attack_ranged_action_frame="3",
					attack_melee_action_frame="3",
					sense_creatures="1",
					attack_ranged_enabled="0",
					attack_melee_enabled="0",
					can_fly="1",
					attack_ranged_entity_file="data/entities/projectiles/orb_pink.xml",
					attack_ranged_frames_between="10",
					eye_offset_y="-5",
					attack_ranged_offset_y="-5",
				})
				EntityAddComponent( entity, "GenomeDataComponent", {
					herd_id="ghost",
					food_chain_rank="7",
					is_predator="1",
				})
				EntityAddComponent( entity, "PathFindingComponent", {
					distance_to_reach_node_x="20",
					distance_to_reach_node_y="20",
					frames_to_get_stuck="120",
				})
				EntityAddComponent( entity, "CharacterPlatformingComponent", {
					run_velocity="24",
				})
				EntityAddComponent( entity, "SpriteAnimatorComponent", {
				
				})
				EntityAddComponent( entity, "DamageModelComponent", {
				    hp="6",
					ragdoll_material="plastic_prop",
					ragdoll_filenames_file="",
					blood_material="water",
					blood_spray_material="water",
					fire_probability_of_ignition="0", 
					air_needed="0",
					blood_sprite_directional="",
					blood_sprite_large="",
				})
				EntityAddTag(entity, "is_mimic")
			end
		end
	end
end