dofile_once("data/scripts/lib/utilities.lua")
local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
local meteors = { "data/entities/projectiles/meteor1.xml", "data/entities/projectiles/meteor2.xml", "data/entities/projectiles/meteor3.xml", "data/entities/projectiles/meteor4.xml", "data/entities/projectiles/meteor5.xml" }
local random_index = Random(1, #meteors)
local meteor = meteors[random_index]

function is_inside_wall(x, y, radius)
  for i=1,8 do
    local slice = math.pi * 2 / 8 * i
    local did_hit, hit_x, hit_y = RaytraceSurfacesAndLiquiform(x, y, x + math.cos(slice) * radius, y + math.sin(slice) * radius)
    if did_hit then
      return true
    end
  end
  return false
end

if not is_inside_wall(x, y, 32) then
  shoot_projectile( entity_id, meteor, x, y, Random(-50,50), 300, false )
end

EntityKill(entity_id)
