function get_state()
  local entity_id = GetUpdatedEntityID()
  state = state or {}
  state[entity_id] = state[entity_id] or {}
  return state[entity_id]
end

local state = get_state()

if state.material == nil then
  local entity_id = GetUpdatedEntityID()
  local variable_storage_components = EntityGetComponent(entity_id, "VariableStorageComponent")
  for i, comp in ipairs(variable_storage_components) do
    local name = ComponentGetValue(comp, "name")
    if name == "material" then
      state.material = ComponentGetValue(comp, "value_string")
    elseif name == "num_particles" then
      state.num_particles = ComponentGetValueInt(comp, "value_int")
    elseif name == "particles_bounce" then
      state.particles_bounce = ComponentGetValueBool(comp, "value_bool")
    end
  end
end

GameEmitRainParticles(state.num_particles, 1024, state.material, 200, 220, 200, state.particles_bounce, true)
