dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once("mods/weather/files/misc/global_multiplier.lua")

local entity_id = GetUpdatedEntityID()
local initialized = entity_id > -1
if entity_id < 0 then
    entity_id = EntityCreateNew()
end
local _, _, day, hour, minute, second = GameGetDateAndTimeLocal()
SetRandomSeed(day + hour + second, minute + second + entity_id)

local delay = Random(0, 60*60*60*5) * global_prob --60*60*60*5)
local script_source_file = "data/scripts/buildings/water_to_blood.lua"

-- This is just so the code in the else doesn't run on the first execution
-- first time execution is just for setting up the delay
if initialized then
    local players = EntityGetWithTag("player_unit")
    if #players > 0 then
        local x, y = EntityGetTransform(players[1])
		local water_to_poison = EntityLoad( "data/entities/animals/water_to_blood.xml", x, y)
		EntityAddChild(players[1], water_to_poison)
        GamePlaySound( "data/audio/Desktop/event_cues.snd", "event_cues/orb_distant_monster/create", x, y )
		EntityLoad( "data/entities/particles/image_emitters/blood_curse.xml", x , y )
        GamePrintImportant( "You Have Been Cursed By The Gods!", "Any water you touch turns to blood" )
        GameScreenshake( 100 )
    end
end

EntityAddComponent(entity_id, "LuaComponent", {
    script_source_file=script_source_file,
    execute_on_added="0",
    remove_after_executed="1",
    execute_every_n_frame=delay,
})


-- local players = EntityGetWithTag("player_unit")

-- function init_spawning(delay, duration)
  -- spawning_delay = delay
  -- spawning_frames_start = GameGetFrameNum() + spawning_delay
  -- spawning_duration = duration
  -- spawning_frames_end = spawning_frames_start + spawning_duration
-- end

-- if #players > 0 then
  -- local x, y = EntityGetTransform(players[1])
  
	-- SetRandomSeed( GameGetFrameNum(), x + y + players[1] )

	  -- if spawning_delay == nil or GameGetFrameNum() > spawning_frames_end then
		-- init_spawning(Random(0, 60 * 60 * 60 * 6), Random(1, 1))
		-- --init_spawning(Random(0, 60 * 60 * 60 * 6), Random(1, 1))
	  -- end
	  
	  -- if GameGetFrameNum() >= spawning_frames_start and GameGetFrameNum() < spawning_frames_end then
		-- local water_to_poison = EntityLoad( "data/entities/animals/water_to_poison.xml", x, y)
		-- EntityAddChild(players[1], water_to_poison)
        -- GamePlaySound( "data/audio/Desktop/event_cues.snd", "event_cues/orb_distant_monster/create", x, y )
		-- EntityLoad( "data/entities/particles/image_emitters/poison_curse.xml", x , y )
        -- GamePrintImportant( "You Have Been Cursed By The Gods!", "Any water you touch turns to poison" )
        -- GameScreenshake( 100 )
	  -- end
  
-- end