dofile_once("data/scripts/lib/utilities.lua")

-- kill self
function death( damage_type_bit_field, damage_message, entity_thats_responsible, drop_items )
	local entity_id    = GetUpdatedEntityID()
	local x, y = EntityGetTransform( entity_id )
	
	local gold_converter_id = EntityCreateNew()
	EntitySetTransform(gold_converter_id, x, y)
	
	local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
	local hitbox_component = EntityGetFirstComponentIncludingDisabled(entity_id, "HitboxComponent")
	
	if hitbox_component and damage_model_component then
	
		local aabb_max_x = ComponentGetValue2(hitbox_component, "aabb_max_x")
		local aabb_min_x = ComponentGetValue2(hitbox_component, "aabb_min_x")
		local aabb_max_y = ComponentGetValue2(hitbox_component, "aabb_max_y")
		local aabb_min_y = ComponentGetValue2(hitbox_component, "aabb_min_y")
		
		function get_distance( x1, y1, x2, y2 )
			local result = math.sqrt( ( x2 - x1 ) ^ 2 + ( y2 - y1 ) ^ 2 )
			return result
		end
		local hitbox_radius = ( get_distance(aabb_min_x, aabb_min_y, aabb_max_x, aabb_max_y) / 2 ) * 2
		
		local ragdoll_material = CellFactory_GetType(ComponentGetValue2(damage_model_component, "ragdoll_material"))
		local material_id = CellFactory_GetType( "ice" )
		
		local comp = EntityAddComponent2(gold_converter_id, "MagicConvertMaterialComponent", {
			from_material=ragdoll_material,
			to_material=material_id,
			steps_per_frame=200,
			loop=true,
			is_circle=true,
			radius=hitbox_radius,
		} )
		
		EntityAddComponent(gold_converter_id, "LifetimeComponent", {
			lifetime="25",
		} )
		
	end
	
end