ModRegisterAudioEventMappings("mods/weather/data/sounds2/GUIDs.txt")
ModMaterialsFileAdd("mods/weather/files/materials/materials.xml")

-- local config = dofile_once("mods/weather/config.lua")

setting_cache = setting_cache or {}
local function get_setting(name)
    setting_cache[name] = setting_cache[name] or ModSettingGet(name)
    return setting_cache[name]
end

function OnPlayerSpawned( player_entity )
	if (GlobalsGetValue("weather_mod_load_done", 0) == "1") then
		return
	end
	
	local went = EntityCreateNew( "weather_controller" )
	if get_setting("weather.locust_plague") then
		EntityAddComponent2(went, "LuaComponent", {
			script_source_file="data/scripts/buildings/locusts.lua",
			execute_every_n_frame=60
		}) 
	end
	if get_setting("weather.frog_plague") then
		EntityAddComponent2(went, "LuaComponent", {
			script_source_file="data/scripts/buildings/frogs.lua",
			execute_every_n_frame=65
		}) 
	end
	if get_setting("weather.meteor_shower") then
		EntityAddComponent2(went, "LuaComponent", {
			script_source_file="data/scripts/buildings/meteors.lua",
			execute_every_n_frame=600
		})
	end
	if get_setting("weather.lightning_storm") then
		EntityAddComponent2(went, "LuaComponent", {
			script_source_file="data/scripts/buildings/lightning_storm.lua",
			execute_every_n_frame=700
		})
	end
	if get_setting("weather.sand_storm") then
		EntityAddComponent2(went, "LuaComponent", {
			script_source_file="data/scripts/buildings/sand_storm.lua",
			execute_every_n_frame=3600
		})
	end
	if get_setting("weather.snow_storm") then
		EntityAddComponent2(went, "LuaComponent", {
			script_source_file="data/scripts/buildings/snow_storm.lua",
			execute_every_n_frame=3600
		})
	end
	if get_setting("weather.sheep_rain") then
		EntityAddComponent2(went, "LuaComponent", {
			script_source_file="data/scripts/buildings/sheep_rain.lua",
			execute_every_n_frame=70
		})
	end
	if get_setting("weather.worm_rain") then
		EntityAddComponent2(went, "LuaComponent", {
			script_source_file="data/scripts/buildings/worm_rain.lua",
			execute_every_n_frame=80
		})
	end
	if get_setting("weather.duck_rain") then
		EntityAddComponent2(went, "LuaComponent", {
			script_source_file="data/scripts/buildings/duck_rain.lua",
			execute_every_n_frame=55
		})
	end
	if get_setting("weather.fish_rain") then
		EntityAddComponent2(went, "LuaComponent", {
			script_source_file="data/scripts/buildings/fish_rain.lua",
			execute_every_n_frame=50
		})
	end
	if get_setting("weather.earthquake") then
		EntityAddComponent2(went, "LuaComponent", {
			script_source_file="data/scripts/buildings/earthquake.lua",
			execute_every_n_frame=1800
		})
	end
	if get_setting("weather.mutant") then
		EntityAddComponent2(went, "LuaComponent", {
			script_source_file="data/scripts/buildings/mutant.lua",
			execute_every_n_frame=600
		})
	end
	if get_setting("weather.haunted_noita") then
		EntityAddComponent2(went, "LuaComponent", {
			script_source_file="data/scripts/buildings/haunted.lua",
			execute_every_n_frame=1200
		})
	end
	if get_setting("weather.drought") then
		EntityAddComponent2(went, "LuaComponent", {
			script_source_file="data/scripts/buildings/drought.lua",
			execute_every_n_frame=360
		})
	end
	if get_setting("weather.ghost_attack") then
		EntityAddComponent2(went, "LuaComponent", {
			script_source_file="data/scripts/buildings/ghosts_starter.lua",
			execute_on_added=true,
			remove_after_executed=true,
			execute_every_n_frame=-1
		})
	end
	if get_setting("weather.death_ray") then
		EntityAddComponent2(went, "LuaComponent", {
			script_source_file="data/scripts/buildings/death_ray_starter.lua",
			remove_after_executed=true,
			execute_every_n_frame=1
		})
	end
	if get_setting("weather.water_to_poison_curse") then
		dofile_once("data/scripts/buildings/water_to_poison.lua")
	end
	if get_setting("weather.water_to_blood_curse") then
		dofile_once("data/scripts/buildings/water_to_blood.lua")
	end
	if get_setting("weather.blood_to_acid_curse") then
		dofile_once("data/scripts/buildings/blood_to_acid.lua")
	end
	if get_setting("weather.corpses_to_gold_curse") then
		dofile_once("data/scripts/buildings/corpses_to_gold.lua")
	end
	if get_setting("weather.corpses_to_poison_curse") then
		dofile_once("data/scripts/buildings/corpses_to_poison.lua")
	end
	-- if config.corpses_to_ice_curse then
		-- dofile_once("data/scripts/buildings/corpses_to_ice.lua")
	-- end
	if get_setting("weather.enable_random_rain") then
		dofile_once("data/scripts/buildings/random_rain_spawner.lua")
	end
	
	GlobalsSetValue("weather_mod_load_done", "1")
	
	-- EntityLoad("data/entities/buildings/ghosts.xml")
	-- EntityLoad("data/entities/buildings/death_ray.xml")
	
	-- dofile( "data/scripts/lib/utilities.lua" )
    -- local players = EntityGetWithTag("player_unit")
    -- local x, y = EntityGetTransform(players[1])
	-- local telepathy = EntityLoad( "data/entities/misc/effect_telepathy.xml", x, y)
	-- EntityAddChild(players[1], telepathy)
end