dofile("data/scripts/lib/mod_settings.lua")

function mod_setting_change_callback( mod_id, gui, in_main_menu, setting, old_value, new_value  )
	print( tostring(new_value) )
end

local mod_id = "weather"
mod_settings_version = 1
mod_settings = 
{
	{
	  id = "global_prob_multiplier",
	  ui_name = "Global Weather Event Multiplier",
	  ui_description = "Change the spawn rate of weather events globally",
	  value_default = 100,
	  value_min = 1,
	  value_max = 200,
	  value_display_multiplier = 1,
	  value_display_formatting = " $0 is to 100 ratio",
	  scope = MOD_SETTING_SCOPE_NEW_GAME,
	},
  
  {
    id = "enable_random_rain",
    ui_name = "Rains",
    ui_description = "Toggle Rain Changes",
    value_default = true,
    scope = MOD_SETTING_SCOPE_NEW_GAME,
	change_fn = function(mod_id, gui, in_main_menu, setting, old_value, new_value)
	  for i, v in ipairs(mod_settings) do
		if v.id == "rain_probability" then
		  v.hidden = (not new_value) == true
		end
		if v.id == "rain_water" then
		  v.hidden = (not new_value) == true
		end
		if v.id == "rain_radioactive_liquid" then
		  v.hidden = (not new_value) == true
		end
		if v.id == "rain_acid" then
		  v.hidden = (not new_value) == true
		end
		if v.id == "rain_blood" then
		  v.hidden = (not new_value) == true
		end
		if v.id == "rain_gunpowder_unstable" then
		  v.hidden = (not new_value) == true
		end
		if v.id == "rain_lava" then
		  v.hidden = (not new_value) == true
		end
		if v.id == "rain_slime" then
		  v.hidden = (not new_value) == true
		end
		if v.id == "rain_gold" then
		  v.hidden = (not new_value) == true
		end
	  end
	end
  },
	{
	  id = "rain_probability",
	  ui_name = "Rain Chance Multiplier",
	  ui_description = "Change the chances that rain occurs",
	  value_default = 4,
	  value_min = 1,
	  value_max = 100,
	  value_display_multiplier = 1,
	  value_display_formatting = " $0 Multiplier",
	  scope = MOD_SETTING_SCOPE_RUNTIME,
	},
  {
    id = "rain_water",
    ui_name = "Water Rain",
    ui_description = "Toggle Water from Rain",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "rain_radioactive_liquid",
    ui_name = "Toxic Sludge Rain",
    ui_description = "Toggle Toxic Sludge from Rain",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "rain_acid",
    ui_name = "Acid Rain",
    ui_description = "Toggle Acid from Rain",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "rain_blood",
    ui_name = "Blood Rain",
    ui_description = "Toggle Blood from Rain",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "rain_gunpowder_unstable",
    ui_name = "Gun Powder Rain",
    ui_description = "Toggle Gun Powder from Rain",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "rain_lava",
    ui_name = "Lava Rain",
    ui_description = "Toggle Lava from Rain",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "rain_slime",
    ui_name = "Slime Rain",
    ui_description = "Toggle Slime from Rain",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "rain_gold",
    ui_name = "Gold Rain",
    ui_description = "Toggle Gold from Rain",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "lightning_storm",
    ui_name = "Lightning",
    ui_description = "Toggle Lightning storms",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "earthquake",
    ui_name = "Earthquake",
    ui_description = "Toggle Earthquakes",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "drought",
    ui_name = "Drought",
    ui_description = "Toggle Droughts",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "sand_storm",
    ui_name = "Sand Storms",
    ui_description = "Toggle Sand Storms",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "snow_storm",
    ui_name = "Snow Storms",
    ui_description = "Toggle Snow Storms",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "locust_plague",
    ui_name = "Locust Plague",
    ui_description = "Toggle Desert Locust Plague",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "frog_plague",
    ui_name = "Frog Plague",
    ui_description = "Toggle Desert Frog Plague",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "meteor_shower",
    ui_name = "Meteor Showers",
    ui_description = "Toggle Meteor Shower",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "corpses_to_gold_curse",
    ui_name = "Corpses To Gold Curse",
    ui_description = "Toggle Corpses to Gold Curse Event",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "corpses_to_poison_curse",
    ui_name = "Corpses To Poison Curse",
    ui_description = "Toggle Corpses to Poison Curse Event",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "water_to_blood_curse",
    ui_name = "Water To Blood Curse",
    ui_description = "Toggle Water to Blood Curse Event",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "water_to_poison_curse",
    ui_name = "Water To Poison Curse",
    ui_description = "Toggle Water to Poison Curse Event",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "blood_to_acid_curse",
    ui_name = "Blood To Acid Curse",
    ui_description = "Toggle Blood to Acid Curse Event",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "haunted_noita",
    ui_name = "Haunted Objects",
    ui_description = "Toggle Haunted Objects Event",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "ghost_attack",
    ui_name = "Ghost Ambush",
    ui_description = "Toggle Ghost Ambush Event",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "death_ray",
    ui_name = "Death Ray",
    ui_description = "Toggle Death Ray Event",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "mutant",
    ui_name = "The Mutant",
    ui_description = "Toggle Mutant Event",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "sheep_rain",
    ui_name = "Sheep Rain",
    ui_description = "Toggle Sheep Rain",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "worm_rain",
    ui_name = "Worm Rain",
    ui_description = "Toggle Worm Rain",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "duck_rain",
    ui_name = "Duck Rain",
    ui_description = "Toggle Duck Rain",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "fish_rain",
    ui_name = "Fish Rain",
    ui_description = "Toggle Fish Rain",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
}

function ModSettingsUpdate( init_scope )
	local old_version = mod_settings_get_version( mod_id )
	mod_settings_update( mod_id, mod_settings, init_scope )
end

function ModSettingsGuiCount()
	return mod_settings_gui_count( mod_id, mod_settings )
end

function ModSettingsGui( gui, in_main_menu )
	mod_settings_gui( mod_id, mod_settings, gui, in_main_menu )
end